//PlotoLog.cpp


#include "PlotoLog.h"
#include <math.h>

gvgbs GBox;

CString FileName;

double DD[100000][2];
double NN; //number of data in file




void StartProgram()
{	
	FileName="plotoxy.dat";
	NN=ReadDataFile();
	if(NN<=0) AfxMessageBox("Data File Error",MB_OK,0);
	int err=PrepareGraphicsBox();
	if(err) AfxMessageBox("Data range Error",MB_OK,0);
	GBox.SetScreen(40,10,90,80);
	GBox.SetXYticks(10,10,3,3,2,2);
}



int ReadDataFile()
{

	FILE *fil=fopen((LPCTSTR)FileName,"rt");
	if(fil==NULL) return -1;
	int count=0;
	double x,y;
	int n=fscanf(fil,"%lf %lf",&x,&y); 
	while(!feof(fil))
	{
		if(n!=2) {fclose(fil); return -2;}
		DD[count][0]=x; DD[count][1]=y;
		count++; n=fscanf(fil,"%lf %lf",&x,&y);
	}
	fclose(fil);
	return count;
}


int PrepareGraphicsBox()
{
	double xmin,xmax,ymin,ymax;
	xmin=xmax=DD[0][0];
	ymin=ymax=DD[0][1];
	for(int i=1;i<NN;i++)
	{
		if(DD[i][0]>xmax) xmax=DD[i][0];
		if(DD[i][0]<xmin) xmin=DD[i][0];
		if(DD[i][1]>ymax) ymax=DD[i][1];
		if(DD[i][1]<ymin) ymin=DD[i][1];
	}
	if(fabs(xmin-xmax)<1.0e-8) return -1;
	if(fabs(ymin-ymax)<1.0e-8) return -1;
	GBox.SetWorld(xmin*1.1,ymin*1.1,xmax*1.1,ymax*1.1);
	return 0;
}
		


